/*
 * The Clear BSD License
 * Copyright 2018 NXP
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted (subject to the limitations in the disclaimer below) provided
 * that the following conditions are met:
 *
 * o Redistributions of source code must retain the above copyright notice, this list
 *   of conditions and the following disclaimer.
 *
 * o Redistributions in binary form must reproduce the above copyright notice, this
 *   list of conditions and the following disclaimer in the documentation and/or
 *   other materials provided with the distribution.
 *
 * o Neither the name of the copyright holder nor the names of its
 *   contributors may be used to endorse or promote products derived from this
 *   software without specific prior written permission.
 *
 * NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE.
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/***********************************************************************************************************************

 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file

 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.

 **********************************************************************************************************************/



/* clang-format off */

/*

 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************

!!GlobalInfo

product: Pins v4.0

processor: MK64FN1M0xxx12

package_id: MK64FN1M0VLL12

mcu_data: ksdk2_0

processor_version: 0.0.12

board: FRDM-K64F

pin_labels:

- {pin_num: '32', pin_signal: ADC0_SE18/PTE25/UART4_RX/I2C0_SDA/EWM_IN, label: 'J2[18]/U8[6]/I2C0_SDA', identifier: ACCEL_I2C_SDA}

- {pin_num: '31', pin_signal: ADC0_SE17/PTE24/UART4_TX/I2C0_SCL/EWM_OUT_b, label: 'J2[20]/U8[4]/I2C0_SCL', identifier: ACCEL_I2C_SCL}

 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********

 */

/* clang-format on */



#include "fsl_common.h"

#include "fsl_port.h"

#include "fsl_gpio.h"

#include "pin_mux.h"



/* FUNCTION ************************************************************************************************************

 *

 * Function Name : BOARD_InitBootPins

 * Description   : Calls initialization functions.

 *

 * END ****************************************************************************************************************/

void BOARD_InitBootPins(void)

{

    BOARD_InitPins();

}



/* clang-format off */

/*

 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************

BOARD_InitPins:

- options: {callFromInitBoot: 'true', prefix: BOARD_, coreID: core0, enableClock: 'true'}

- pin_list:

  - {pin_num: '62', peripheral: UART0, signal: RX, pin_signal: PTB16/SPI1_SOUT/UART0_RX/FTM_CLKIN0/FB_AD17/EWM_IN}

  - {pin_num: '63', peripheral: UART0, signal: TX, pin_signal: PTB17/SPI1_SIN/UART0_TX/FTM_CLKIN1/FB_AD16/EWM_OUT_b}

  - {pin_num: '68', peripheral: GPIOB, signal: 'GPIO, 22', pin_signal: PTB22/SPI2_SOUT/FB_AD29/CMP2_OUT, direction: OUTPUT, gpio_init_state: 'true'}

  - {pin_num: '33', peripheral: GPIOE, signal: 'GPIO, 26', pin_signal: PTE26/ENET_1588_CLKIN/UART4_CTS_b/RTC_CLKOUT/USB_CLKIN, direction: OUTPUT, gpio_init_state: 'true'}

 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********

 */

/* clang-format on */



/* FUNCTION ************************************************************************************************************

 *

 * Function Name : BOARD_InitPins

 * Description   : Configures pin routing and optionally pin electrical features.

 *

 * END ****************************************************************************************************************/

void BOARD_InitPins(void)

{

    /* Port B Clock Gate Control: Clock enabled */

    CLOCK_EnableClock(kCLOCK_PortB);

    /* Port E Clock Gate Control: Clock enabled */

    CLOCK_EnableClock(kCLOCK_PortE);



    gpio_pin_config_t LED_RED_config = {

        .pinDirection = kGPIO_DigitalOutput,

        .outputLogic = 1U

    };

    /* Initialize GPIO functionality on pin PTB22 (pin 68)  */

    GPIO_PinInit(BOARD_LED_RED_GPIO, BOARD_LED_RED_PIN, &LED_RED_config);



    gpio_pin_config_t LED_GREEN_config = {

        .pinDirection = kGPIO_DigitalOutput,

        .outputLogic = 1U

    };

    /* Initialize GPIO functionality on pin PTE26 (pin 33)  */

    GPIO_PinInit(BOARD_LED_GREEN_GPIO, BOARD_LED_GREEN_PIN, &LED_GREEN_config);



    /* PORTB16 (pin 62) is configured as UART0_RX */

    PORT_SetPinMux(BOARD_DEBUG_UART_RX_PORT, BOARD_DEBUG_UART_RX_PIN, kPORT_MuxAlt3);



    /* PORTB17 (pin 63) is configured as UART0_TX */

    PORT_SetPinMux(BOARD_DEBUG_UART_TX_PORT, BOARD_DEBUG_UART_TX_PIN, kPORT_MuxAlt3);



    /* PORTB22 (pin 68) is configured as PTB22 */

    PORT_SetPinMux(BOARD_LED_RED_PORT, BOARD_LED_RED_PIN, kPORT_MuxAsGpio);



    /* PORTE26 (pin 33) is configured as PTE26 */

    PORT_SetPinMux(BOARD_LED_GREEN_PORT, BOARD_LED_GREEN_PIN, kPORT_MuxAsGpio);



    SIM->SOPT5 = ((SIM->SOPT5 &

                   /* Mask bits to zero which are setting */

                   (~(SIM_SOPT5_UART0TXSRC_MASK)))



                  /* UART 0 transmit data source select: UART0_TX pin. */

                  | SIM_SOPT5_UART0TXSRC(SOPT5_UART0TXSRC_UART_TX));

}



/* clang-format off */

/*

 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************

BOARD_I2C_ConfigurePins:

- options: {callFromInitBoot: 'false', prefix: BOARD_, coreID: core0, enableClock: 'true'}

- pin_list:

  - {pin_num: '31', peripheral: I2C0, signal: SCL, pin_signal: ADC0_SE17/PTE24/UART4_TX/I2C0_SCL/EWM_OUT_b, identifier: '', slew_rate: fast, open_drain: enable, drive_strength: low,

    pull_select: up, pull_enable: enable, passive_filter: disable}

  - {pin_num: '32', peripheral: I2C0, signal: SDA, pin_signal: ADC0_SE18/PTE25/UART4_RX/I2C0_SDA/EWM_IN, identifier: '', slew_rate: fast, open_drain: enable, drive_strength: low,

    pull_select: up, pull_enable: enable, passive_filter: disable}

 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********

 */

/* clang-format on */



/* FUNCTION ************************************************************************************************************

 *

 * Function Name : BOARD_I2C_ConfigurePins

 * Description   : Configures pin routing and optionally pin electrical features.

 *

 * END ****************************************************************************************************************/

void BOARD_I2C_ConfigurePins(void)

{

    /* Port E Clock Gate Control: Clock enabled */

    CLOCK_EnableClock(kCLOCK_PortE);



    const port_pin_config_t porte24_pin31_config = {/* Internal pull-up resistor is enabled */

                                                    kPORT_PullUp,

                                                    /* Fast slew rate is configured */

                                                    kPORT_FastSlewRate,

                                                    /* Passive filter is disabled */

                                                    kPORT_PassiveFilterDisable,

                                                    /* Open drain is enabled */

                                                    kPORT_OpenDrainEnable,

                                                    /* Low drive strength is configured */

                                                    kPORT_LowDriveStrength,

                                                    /* Pin is configured as I2C0_SCL */

                                                    kPORT_MuxAlt5,

                                                    /* Pin Control Register fields [15:0] are not locked */

                                                    kPORT_UnlockRegister};

    /* PORTE24 (pin 31) is configured as I2C0_SCL */

    PORT_SetPinConfig(PORTE, 24U, &porte24_pin31_config);



    const port_pin_config_t porte25_pin32_config = {/* Internal pull-up resistor is enabled */

                                                    kPORT_PullUp,

                                                    /* Fast slew rate is configured */

                                                    kPORT_FastSlewRate,

                                                    /* Passive filter is disabled */

                                                    kPORT_PassiveFilterDisable,

                                                    /* Open drain is enabled */

                                                    kPORT_OpenDrainEnable,

                                                    /* Low drive strength is configured */

                                                    kPORT_LowDriveStrength,

                                                    /* Pin is configured as I2C0_SDA */

                                                    kPORT_MuxAlt5,

                                                    /* Pin Control Register fields [15:0] are not locked */

                                                    kPORT_UnlockRegister};

    /* PORTE25 (pin 32) is configured as I2C0_SDA */

    PORT_SetPinConfig(PORTE, 25U, &porte25_pin32_config);

}



/* clang-format off */

/*

 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************

BOARD_Init_I2C_GPIO_pins:

- options: {callFromInitBoot: 'false', prefix: BOARD_, coreID: core0, enableClock: 'true'}

- pin_list:

  - {pin_num: '31', peripheral: GPIOE, signal: 'GPIO, 24', pin_signal: ADC0_SE17/PTE24/UART4_TX/I2C0_SCL/EWM_OUT_b, direction: OUTPUT, gpio_init_state: 'true'}

  - {pin_num: '32', peripheral: GPIOE, signal: 'GPIO, 25', pin_signal: ADC0_SE18/PTE25/UART4_RX/I2C0_SDA/EWM_IN, direction: OUTPUT, gpio_init_state: 'true'}

 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********

 */

/* clang-format on */



/* FUNCTION ************************************************************************************************************

 *

 * Function Name : BOARD_Init_I2C_GPIO_pins

 * Description   : Configures pin routing and optionally pin electrical features.

 *

 * END ****************************************************************************************************************/

void BOARD_Init_I2C_GPIO_pins(void)

{

    /* Port E Clock Gate Control: Clock enabled */

    CLOCK_EnableClock(kCLOCK_PortE);



    gpio_pin_config_t ACCEL_I2C_SCL_config = {

        .pinDirection = kGPIO_DigitalOutput,

        .outputLogic = 1U

    };

    /* Initialize GPIO functionality on pin PTE24 (pin 31)  */

    GPIO_PinInit(BOARD_ACCEL_I2C_SCL_GPIO, BOARD_ACCEL_I2C_SCL_PIN, &ACCEL_I2C_SCL_config);



    gpio_pin_config_t ACCEL_I2C_SDA_config = {

        .pinDirection = kGPIO_DigitalOutput,

        .outputLogic = 1U

    };

    /* Initialize GPIO functionality on pin PTE25 (pin 32)  */

    GPIO_PinInit(BOARD_ACCEL_I2C_SDA_GPIO, BOARD_ACCEL_I2C_SDA_PIN, &ACCEL_I2C_SDA_config);



    /* PORTE24 (pin 31) is configured as PTE24 */

    PORT_SetPinMux(BOARD_ACCEL_I2C_SCL_PORT, BOARD_ACCEL_I2C_SCL_PIN, kPORT_MuxAsGpio);



    /* PORTE25 (pin 32) is configured as PTE25 */

    PORT_SetPinMux(BOARD_ACCEL_I2C_SDA_PORT, BOARD_ACCEL_I2C_SDA_PIN, kPORT_MuxAsGpio);

}

/***********************************************************************************************************************

 * EOF

 **********************************************************************************************************************/

